## samba 4.23.0~rc1+dfsg

=== debian/changelog ===
samba (2:4.23.0~rc1+dfsg-1) experimental; urgency=medium

  * new upstream release candidate
  * d/gbp.conf: switch to 4.23 upstream branch
  * d/rules: tevent=0.17.1 tdb=1.4.14
  * libads-fix-get_kdc_ip_string.patch: remove (included upstream)
  * d/copyright: remove entries for two removed files
  * d/libpam-winbind.install: install message catalogs
  * d/samba-common-bin.install: install message catalog(s) for the net command
  * d/libsmbclient0.symbols,d/libtevent0t64.symbols: add new symbols
  * d/libtdb1.symbols: add new version
  * d/samba-dsdb-modules.install: add new AD module (trust_notify.so)
  * d/samba-libs.install: refresh private libraries list (-1, +4 libs)
  * d/rules: explicitly specify --pythondir= & --pythonarchdir=
    (so it doesn't install to /usr/lib/python3.13/site-packages/)
  * d/rules,d/lib{nss,pam}-winbind.install: use ${SYSLIBDIR}
    for /lib vs /usr/lib, stop using dh_movetousr

 -- Michael Tokarev <mjt@tls.msk.ru>  Thu, 07 Aug 2025 23:29:29 +0300

=== debian/rules ===
#!/usr/bin/make -f
SHELL = /bin/sh -e

# Fast version of dpkg/architecture.mk defining all vars in one go
ifeq (${DEB_HOST_MULTIARCH},)
   $(foreach d, $(shell dpkg-architecture | sed 's/=/?=/'), $(eval export $d))
endif

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

# build is done in bin/default/ subdir
DEB_CFLAGS_MAINT_APPEND = -ffile-prefix-map=../../=

ifneq (,$(filter armel mipsel m68k powerpc sh4,${DEB_HOST_ARCH}))
# https://gcc.gnu.org/bugzilla/show_bug.cgi?id=81358
# on these platforms gcc does not link with -latomic, resulting in
#   third_party/heimdal/lib/krb5/krcache.c.55.o: in function `krcc_get_principal':
#   third_party/heimdal/lib/krb5/krcache.c:1395: undefined reference to `__atomic_load_8'
#     ids.krcu_cache_and_princ_id = heim_base_atomic_load(&data->krc_cache_and_principal_id);
#   third_party/heimdal/lib/base/heimbase-atomics.h:
#     #include <stdatomic.h>
#     #define heim_base_atomic_load(x)        atomic_load((x))
# include a workaround for now
# (-latomic and <stdatomic.h> comes from gcc, --as-needed is already in use)
DEB_LDFLAGS_MAINT_APPEND += -latomic
endif

ifneq (,$(filter m68k ,${DEB_HOST_ARCH}))
# without this, build fails with multiple messages like:
# foo.s:NNN: Error: Adjusted signed .word (0xb64a) overflows: `switch'-statement too large.
# when building third_party/heimdal/lib/asn1/asn1_rfc2459_asn1.c (generated)
# It would be best to enable this switch for a single file only (where it is needed)
DEB_CFLAGS_MAINT_APPEND += -mlong-jump-table-offsets
endif

include /usr/share/dpkg/buildtools.mk
include /usr/share/dpkg/buildflags.mk
include /usr/share/dpkg/pkg-info.mk
include /usr/share/dpkg/vendor.mk
V := $(if $(filter terse, ${DEB_BUILD_OPTIONS}),,1)
WAF := PYTHONHASHSEED=1 ./buildtools/bin/waf \
	$(patsubst parallel=%,-j%,$(filter parallel=%,${DEB_BUILD_OPTIONS}))

# stop python from generating .pyc caches
export PYTHONDONTWRITEBYTECODE=1

ifeq (linux,${DEB_HOST_ARCH_OS})
ifneq (${DEB_HOST_GNU_TYPE},${DEB_BUILD_GNU_TYPE})
# for cross-build or build with foreign python binary (it is _gnu0_i386-gnu on hurd)
export _PYTHON_SYSCONFIGDATA_NAME=_sysconfigdata__${DEB_HOST_ARCH_OS}_${DEB_HOST_MULTIARCH}
endif
endif

PYTHONDIR = /usr/lib/python3/dist-packages

DESTDIR = ${CURDIR}/debian/tmp

before-trixie := $(filter pkg.samba.before-trixie, ${DEB_BUILD_PROFILES})

subver-suffix := +samba${DEB_VERSION_UPSTREAM_REVISION}

# lib/ldb/wscript
ldb-upstream-version := 2.11.0
ldb-version = 2:${ldb-upstream-version}${subver-suffix}
ldb-packages := libldb2 libldb-dev ldb-tools python3-ldb

# lib/talloc/wscript
talloc-upstream-version := 2.4.3
talloc-version = 2:${talloc-upstream-version}${subver-suffix}
talloc-packages := libtalloc2 libtalloc-dev python3-talloc

# lib/tevent/wscript
tevent-upstream-version := 0.17.1
tevent-version = 2:${tevent-upstream-version}${subver-suffix}
libtevent := $(if ${before-trixie},libtevent0,libtevent0t64)
tevent-packages := ${libtevent} libtevent-dev

# lib/tdb/wscript
tdb-upstream-version := 1.4.14
tdb-version = 2:${tdb-upstream-version}${subver-suffix}
tdb-packages := libtdb1 tdb-tools libtdb-dev python3-tdb

extra-version-vars = \
	-Vldb:Version=${ldb-version} \

# used in libnss-winbind.install & libpam-winbind.install
export SYSLIBDIR = $(if ${before-trixie},/lib,/usr/lib)

omit-pkgs =

config-args = \
	--vendor-suffix=${DEB_VENDOR}-${DEB_VERSION_UPSTREAM_REVISION} \
	--prefix=/usr \
	--enable-fhs \
	--sysconfdir=/etc \
	--localstatedir=/var \
	--libexecdir=/usr/libexec \
	--libdir=/usr/lib/${DEB_HOST_MULTIARCH} \
	--datadir=/usr/share \
	--with-modulesdir=/usr/lib/${DEB_HOST_MULTIARCH}/samba \
	--with-pammodulesdir=${SYSLIBDIR}/${DEB_HOST_MULTIARCH}/security \
	--with-privatedir=/var/lib/samba/private \
	--with-smbpasswd-file=/etc/samba/smbpasswd \
	--with-piddir=/run/samba \
	--with-lockdir=/run/samba \
	--with-sockets-dir=/run/samba \
	--with-statedir=/var/lib/samba \
	--with-cachedir=/var/cache/samba \
	--with-pam \
	--with-syslog \
	--with-utmp \
	--with-winbind \
	--with-automount \
	--with-ldap \
	--with-ads \
	--with-gpgme \
	--enable-avahi \
	--enable-spotlight \
	--with-profiling-data \
	--disable-rpath --disable-rpath-install \
	--private-libraries=!ldb \
	--bundled-libraries=talloc,tevent,tdb \
	--pythondir=${PYTHONDIR} \
	--pythonarchdir=${PYTHONDIR} \
	\
	--with-cluster-support \
	--enable-etcd-reclock \
	--with-socketpath=/run/ctdb/ctdbd.socket \
	--with-logdir=/var/log/ctdb \

# some modules are linked statically by default (see default_static_module in wscript*),
# but they're often linked into other libraries, which might result in cyclic deps.
# Eg, vfs_dfs_samba4 is statically linked to libsmbd-base-private, which is part of
# samba-libs (not samba), because it is used by python3-samba too (smbd.cpython).
# Might consider using --with-shared-modules=ALL
# Other modules (vfs_nfs4acl_xattr) are not enabled by default (#930540).
config-args += \
	--with-shared-modules=vfs_dfs_samba4,vfs_nfs4acl_xattr,auth_samba4

ifeq (${DEB_HOST_ARCH_OS}, linux) # extra linux-specific features

config-args += \
	--with-quota \
	--with-systemd \

endif

# Ubuntu i386 binary compatibility only effort: Disable some i386 packages and modules
ifeq (${DEB_VENDOR}-${DEB_HOST_ARCH}, Ubuntu-i386)
omit-pkgs += ctdb libpam-winbind samba samba-ad-dc samba-testsuite samba-vfs-modules samba-vfs-ceph samba-vfs-glusterfs
endif

# we had t64 transition (libsmbclient => libsmbclient0) for trixie
libsmbclient := $(if ${before-trixie},libsmbclient,libsmbclient0)

mitkrb5-dep-pkgs :=
ifneq (,$(filter pkg.samba.mitkrb5, ${DEB_BUILD_PROFILES}))
config-args += \
	--with-system-mitkrb5 \
	--with-experimental-mit-ad-dc \
	--with-system-mitkdc=/usr/sbin/krb5kdc
# samba packages will have its own version suffix
mitkrb5-samba-ver = ${DEB_VERSION}mitkrb5
mitkrb5-dep-pkgs += samba-libs samba-dev
mitkrb5-dep-pkgs += samba samba-common-bin python3-samba
mitkrb5-dep-pkgs += samba-vfs-ceph samba-vfs-glusterfs
mitkrb5-dep-pkgs += samba-dsdb-modules
mitkrb5-dep-pkgs += ${libsmbclient} smbclient
mitkrb5-dep-pkgs += libnss-winbind libpam-winbind
mitkrb5-dep-pkgs += winbind libwbclient0
mitkrb5-dep-pkgs += samba-testsuite
mitkrb5-dep-pkgs += ctdb
endif

ifneq (,${omit-pkgs})
export DH_OPTIONS += $(addprefix -N, ${omit-pkgs})
endif
# ${build-pkgs} will honour arch/indep and the above list in ${DH_OPTIONS}
build-pkgs := $(shell dh_listpackages)

with-ceph := $(filter samba-vfs-ceph,${build-pkgs})
config-args += $(if ${with-ceph},\
	  --enable-cephfs --enable-ceph-reclock,\
	  --disable-cephfs)

binary binary-arch binary-indep \
install install-arch install-indep: %:
	dh $*

configure: bin/configured.stamp
.PHONY: configure
bin/configured.stamp:
	CC="${CC}" CPP="${CPP}" LD="${LD}" PKGCONFIG="${PKG_CONFIG}" \
	CPPFLAGS="${CPPFLAGS}" CFLAGS="${CFLAGS}" LDFLAGS="${LDFLAGS}" \
	PYTHON=python3 PYTHON_CONFIG=${DEB_HOST_MULTIARCH}-python3-config \
	    ${WAF} -j1 -C configure ${config-args} || \
	  { $(if ${V},echo "==== contents of config.log:"; cat bin/config.log;) false; }
# #1013205: https://lists.samba.org/archive/samba-technical/2022-November/137788.html
	rm -f third_party/heimdal/lib/gssapi/gssapi.h
	touch $@

build-arch: bin/built.stamp
bin/built.stamp: bin/configured.stamp
# samba build system is designed so that default build (what is produced
# by waf build) supposed to be run directly from the build directory,
# with all the paths pointing there.  At the install stage, quite some
# recompilation/relinking is done again, to adopt to the actual install
# paths. There's no need (for now) to build samba to be run from the build
# directory, so we use `waf install' here instead of `waf build'.
ifeq (,${mitkrb5-dep-pkgs})
# However, as of 4.16 and still 4.21, `waf install' without the build step fails,
# since it tries to run two executables which are not built.
# Build these two executables first, and build the install stage.
# This will pefrorm unnecessary/extra install step (into d/tmp), which

## samba 4.23.0~rc2+dfsg

=== debian/changelog ===
samba (2:4.23.0~rc2+dfsg-1) experimental; urgency=medium

  * new upstream release candidate

 -- Michael Tokarev <mjt@tls.msk.ru>  Sat, 23 Aug 2025 01:52:34 +0300

## samba 4.23.0~rc3+dfsg

=== debian/changelog ===
samba (2:4.23.0~rc3+dfsg-1) experimental; urgency=medium

  * new upstream release candidate
  * d/libnss-winbind.triggers: remove, ldconfig call is generated by genshlibs

 -- Michael Tokarev <mjt@tls.msk.ru>  Fri, 29 Aug 2025 23:27:18 +0300

=== debian/control ===
Source: samba
Section: net
Priority: optional
Maintainer: Debian Samba Maintainers <pkg-samba-maint@lists.alioth.debian.org>
Uploaders: Jelmer Vernooĳ <jelmer@debian.org>,
           Mathieu Parent <sathieu@debian.org>,
           Michael Tokarev <mjt@tls.msk.ru>
Homepage: https://www.samba.org
Standards-Version: 4.7.0
Build-Depends:
	debhelper-compat (= 13),
	dh-exec,
Build-Depends-Arch:
	dh-sequence-python3,
        python3-setuptools,
	dpkg-dev (>= 1.22.5) <!pkg.samba.before-trixie>,
# tools:
	bison,
	docbook-xml, docbook-xsl, xsltproc,
	flex,
	perl:any,
# :native for bookworm, on trixie and up it is not needed
	libparse-yapp-perl:native | libparse-yapp-perl,
	rpcsvc-proto  <!pkg.samba.before-trixie>,
# for winexe. gcc-mingw-w64 brings 4 toolchains, we need only 2
        gcc-mingw-w64-i686-win32, gcc-mingw-w64-x86-64-win32,
# system libraries:
	pkgconf,
	libacl1-dev,
	libarchive-dev,
	libavahi-client-dev,
	libavahi-common-dev,
	libblkid-dev,
	libbsd-dev,
	libcap-dev [linux-any],
# the same [arch list] is in ctdb.install
	libcephfs-dev [amd64 arm64 mips64el ppc64el riscv64 s390x],
	librados-dev  [amd64 arm64 mips64el ppc64el riscv64 s390x],
	libcmocka-dev,
	libcrypt-dev,
	libcups2-dev,
	libdbus-1-dev,
	libglusterfs-dev [amd64 arm64 loong64 mips64el ppc64 ppc64el riscv64 s390x sparc64],
	libgnutls28-dev,
	libgpgme11-dev,
	libicu-dev,
	libjansson-dev,
	libkeyutils-dev [linux-any],
	libkrb5-dev (>= 1.21.0~) <pkg.samba.mitkrb5>,
	libldap2-dev,
	liblmdb-dev,
#	libngtcp2-dev (>> 1.12.0~) [linux-any],
#	libngtcp2-crypto-gnutls-dev (>> 1.12.0~) [linux-any],
	libpam0g-dev,
	libpcap-dev [hurd-any],
	libpopt-dev,
	libreadline-dev,
	libtirpc-dev,
	libsystemd-dev [linux-any],
	libtasn1-6-dev,
	libtasn1-bin,
	liburing-dev [linux-any],
# xfslibs-dev is not multi-arch-usable but we only need .h (#1092689)
	xfslibs-dev:native [linux-any],
	zlib1g-dev,
# python (+#904999):
	python3-dev:native, libpython3-dev,
# :native for bookworm, for trixie and up it is not needed
	python3-dnspython:native | python3-dnspython,
	python3-etcd:native | python3-etcd,
	python3-markdown:native | python3-markdown,
# dependencies needed for selftest:
#	python3-testtools <!nocheck>,
#	lmdb-utils <!nocheck>,
#	openssl <!nocheck>,
#	python3-cryptography <!nocheck>,
#	python3-iso8601 <!nocheck>,
#	python3-pyasn1 <!nocheck>,
#	tdb-tools <!nocheck>,
Rules-Requires-Root: no
Vcs-Browser: https://salsa.debian.org/samba-team/samba
Vcs-Git: https://salsa.debian.org/samba-team/samba.git

Package: samba
Architecture: any
Pre-Depends: ${misc:Pre-Depends}
Depends: passwd,
         procps,
         samba-common,
         samba-common-bin (=${binary:Version}),
         ${misc:Depends},
         ${python3:Depends},
         ${shlibs:Depends}
Recommends: attr,
            python3-samba,
# samba-ad-dc has been split out of samba in 4.20.1+dfsg-2.  Keep it
# in Recommends for one release cycle to avoid breaking existing installs
            samba-ad-dc,
Suggests: ctdb,
          ufw,
          winbind,
          samba-vfs-ceph, samba-vfs-glusterfs,
# move libdfs-server-ad-samba4.so.0 samba-libs=>samba-vfs-modules in 4.19.0~rc1
# swallow samba-vfs-modules by samba in 4.20.2-dfsg-3
Replaces: samba-libs (<< 2:4.19.0~),
          samba-vfs-modules (<< 2:4.20.2+dfsg-3~),
Breaks:   samba-ad-provision (<< ${source:Upstream-Version}),
          samba-libs (<< 2:4.19.0~),
          samba-vfs-modules (<< 2:4.20.2+dfsg-3~),
          samba-ad-dc (<< 2:4.20.1+dfsg-2~),
Description: SMB/CIFS file, print, and login server for Unix
 Samba is an implementation of the SMB/CIFS protocol for Unix systems,
 providing support for cross-platform file and printer sharing with
 Microsoft Windows, OS X, and other Unix systems.  Samba can also function
 as an Active Directory or NT4-style domain controller, and can integrate
 with Active Directory realms or NT4 domains as a member server.
 .
 This package provides the components necessary to use Samba as a stand-alone
 file and print server or as an NT4 domain controller.  For use in an NT4
 domain or Active Directory realm, you will also need the winbind package.
 To use samba as an Active Directory domain controller (AD DC), please install
 samba-ad-dc package.
 .
 This package is not required for connecting to existing SMB/CIFS servers
 (see smbclient) or for mounting remote filesystems (see cifs-utils).

Package: samba-libs
Pre-Depends: ${misc:Pre-Depends}
Multi-Arch: same
Architecture: any
Section: libs
Provides: libndr6 (= ${binary:Version}),
# libndr5=>6 dropped 3 long-unused KRB5_EDATA_NTSTATUS symbols
 libndr5 (= ${binary:Version}),
 libsmbldap2 (= ${binary:Version})
Depends: ${misc:Depends}, ${shlibs:Depends},
# since libldb ABI is incorrectly versioned resulting in breakage like #1021371,
# just require libldb version of the same build
# https://lists.samba.org/archive/samba-technical/2023-September/138422.html
 libldb2 (= ${ldb:Version}),
Replaces:
# libsamba-util.so &deps moved from libwbclient0 to samba-libs in 4.16.1+dfsg-7
 libwbclient0 (<< 2:4.16.1+dfsg-7~),
# libpac-samba4.so.0 moved from samba to samba-libs in 4.17.0+dfsg-2
 samba (<< 2:4.17.0+dfsg-2~),
Breaks:
 libwbclient0 (<< 2:4.16.1+dfsg-7~),
 samba (<< 2:4.17.0+dfsg-2~),
 sssd-ad (<< 2.9.4-1+b1),
 sssd-ad-common (<< 2.9.4-1+b1),
 sssd-ipa (<< 2.9.4-1+b1),
Description: Samba core libraries
 Samba is an implementation of the SMB/CIFS protocol for Unix systems,
 providing support for cross-platform file sharing with Microsoft Windows, OS X,
 and other Unix systems.  Samba can also function as a domain controller
 or member server in Active Directory or NT4-style domains.
 .
 This package contains the shared libraries.

Package: samba-common
Architecture: all
Multi-Arch: foreign
Pre-Depends: ${misc:Pre-Depends}
Depends: ucf, ${misc:Depends}
Recommends: samba-common-bin
Description: common files used by both the Samba server and client
 Samba is an implementation of the SMB/CIFS protocol for Unix systems,
 providing support for cross-platform file and printer sharing with
 Microsoft Windows, OS X, and other Unix systems.
 .
 This package contains common files used by all parts of Samba.

Package: samba-common-bin
Architecture: any
Depends: samba-common,
         ${misc:Depends},
         ${python3:Depends},
         ${shlibs:Depends}
Recommends: python3-samba,
Suggests: heimdal-clients,
# moved libnet-keytab-samba4.so.0 & libRPC-WORKER-samba4.so.0 samba-libs=>samba-common-bin in 4.19.0~r1
# moved smbcontrol samba=>samba-common-bin in 4.20.0-2
# in kali linux, winexe initially has been in its own pkg (#1081269)
Replaces: samba (<< 2:4.20.1+dfsg-2~), samba-libs (<< 2:4.19.0~), winexe (<< 2:4.21.1+dfsg-3~)
Breaks:   samba (<< 2:4.20.1+dfsg-2~), samba-libs (<< 2:4.19.0~), winexe (<< 2:4.21.1+dfsg-3~)
Provides: winexe (= ${binary:Version})
Description: Samba common files used by both the server and the client
 Samba is an implementation of the SMB/CIFS protocol for Unix systems,
 providing support for cross-platform file sharing with Microsoft Windows, OS X,
 and other Unix systems.  Samba can also function as a domain controller
 or member server in Active Directory or NT4-style domains.
 .
 This package contains the common files that are used by both the server
 (provided in the samba package) and the client (provided in the smbclient
 package).

Package: samba-ad-dc
Architecture: any
Multi-Arch: foreign
Pre-Depends: ${misc:Pre-Depends}
Depends: samba (= ${binary:Version}),
	 python3-samba (= ${binary:Version}),
	 python3-dnspython,
	 samba-dsdb-modules (= ${binary:Version}),
	 winbind (= ${binary:Version}),
	 krb5-kdc (>= 1.21.0~) <pkg.samba.mitkrb5>,
	 ${python3:Depends},
	 ${shlibs:Depends},
	 ${misc:Depends}
Recommends: libnss-winbind, libpam-winbind,
# samba-ad-provision is needed for setup only
	samba-ad-provision,
# used in a few AD-related subcommands of samba-tool (see #876984)
        python3-gpg,
Suggests: bind9,
	  bind9utils,
	  ldb-tools,
# Besides wanting accurate time, samba DC can provide signed time source
# to the domain using special socket (see "ntp signd socket directory"
# in smb.conf(5)).  There was a (wrong) patch to ntp to work with samba,
# it has been dropped in ntpsec.
	  time-daemon | chrony | ntpsec,
Enhances: bind9, ntpsec
Breaks:   samba-ad-provision (<< ${source:Upstream-Version}),
# files moved from samba & samba-common-bin in 4.20.1-2:
	  samba-common-bin (<< 2:4.20.1+dfsg-2~),
Replaces: samba-common-bin (<< 2:4.20.1+dfsg-2~),
# Breaks+Replaces upgraded to Conflicts for DEP17 + /usr-move
Conflicts: samba (<< 2:4.20.1+dfsg-2~),
Description: Samba control files to run AD Domain Controller
 Samba is an implementation of the SMB/CIFS protocol for Unix systems,
 providing support for cross-platform file and printer sharing with
 Microsoft Windows, OS X, and other Unix systems.
 .
 This package contains control files to run an Active Directory Domain
 Controller (AD DC).  For now, this is just a metapackage pulling in
 all the required dependencies.

Package: samba-ad-provision
Architecture: all
Multi-Arch: foreign
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends},
 python3-markdown,
Replaces: samba (<< 2:4.17.3+dfsg-4~)
Breaks:   samba (<< 2:4.17.3+dfsg-4~)
Description: Samba files needed for AD domain provision
 Samba is an implementation of the SMB/CIFS protocol for Unix systems,
 providing support for cross-platform file and printer sharing with
 Microsoft Windows, OS X, and other Unix systems.
 .
 This package contains files to setup an Active Directory Domain
 Controller (AD DC).

Package: smbclient
Architecture: any
Depends: samba-common,
         samba-libs (= ${binary:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Provides: samba-client
Suggests: cifs-utils, heimdal-clients
Description: command-line SMB/CIFS clients for Unix
 Samba is an implementation of the SMB/CIFS protocol for Unix systems,
 providing support for cross-platform file and printer sharing with
 Microsoft Windows, OS X, and other Unix systems.
 .
 This package contains command-line utilities for accessing Microsoft
 Windows and Samba servers, including smbclient, smbtar, and smbspool.
 Utilities for mounting shares locally are found in the package
 cifs-utils.

Package: samba-testsuite
Architecture: any
Suggests: subunit
Depends: samba-common-bin,
         samba-libs (= ${binary:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
# move libshares-samba4.so.0 samba-libs=>samba-testsuite in 4.19.0~rc1
Replaces: samba-libs (<< 2:4.19.0~)
Breaks:   samba-libs (<< 2:4.19.0~)
Description: test suite from Samba
 Samba is an implementation of the SMB/CIFS protocol for Unix systems,
 providing support for cross-platform file sharing with Microsoft Windows, OS X,
 and other Unix systems.  Samba can also function as a domain controller
 or member server in Active Directory or NT4-style domains.
 .
 This package contains programs for testing the reliability and speed
 of SMB servers, Samba in particular.

Package: registry-tools
Architecture: any
Depends: samba-libs (= ${binary:Version}), ${misc:Depends}, ${shlibs:Depends}
Description: tools for viewing and manipulating the Windows registry
 Samba is an implementation of the SMB/CIFS protocol for Unix systems,
 providing support for cross-platform file sharing with Microsoft Windows, OS X,
 and other Unix systems.  Samba can also function as a domain controller
 or member server in Active Directory or NT4-style domains.
 .
 This package contains tools for viewing and manipulating the binary
 "registry" found on Windows machines, both locally and remote.

Package: samba-dev
Architecture: any
Multi-Arch: same
Depends: libc6-dev,
         libldb-dev,
         libpopt-dev,
         libtalloc-dev,
         libtdb-dev,
         libtevent-dev,
         libwbclient-dev,
         samba-libs (= ${binary:Version}),
         ${misc:Depends}
# libsamba-util.so moved from libwbclient0 to samba-libs in 4.16.1+dfsg-7
Replaces: libwbclient-dev (<< 2:4.16.1+dfsg-7~)

## samba 4.23.0+dfsg

=== debian/changelog ===
samba (2:4.23.0+dfsg-3) unstable; urgency=medium

  * libmscat-deps.patch (Closes: #1103869)
  * disable building undocumented dumpmscat binary, but provide
    pkg.samba.dumpmscat build profile to enable buildig it
  * enable system libngtcp2 (for !pkg.samba.builtin-ngtcp2 build profile)
  * d/control: describe all current build profiles
  * d/smb.conf: disable netbios by default
  * d/samba.postinst: remove hunk for samba << 4.16.0 (pre-bookworm)
    concerning socket directory
  * d/samba.postinst: remove hunk for samba << 4.17.4-3 (pre-bookworm)
    concerning handling of samba spool dir
  * d/samba.postinst: remove hunk for samba << 4.17.4-3 (pre-bookworm)
    concerning masking of services
  * d/winbind.postinst: remove hunk for samba << 4.17.4-3 (pre-bookworm)
    concerning masking of services
  * d/samba-common.postinst: actually clean-up old debconf entries
  * d/changelog: fix typo in previous entry

 -- Michael Tokarev <mjt@tls.msk.ru>  Tue, 16 Sep 2025 16:17:37 +0300

samba (2:4.23.0+dfsg-2) unstable; urgency=medium

  * d/rules: override dh_gencontrol for arch build only
    (no need to do that for indep build)
  * d/samba-libs.install: libquic is linux-specific
  * d/samba-libs.install: ngtcp2 is linux-specific, not non-hurd
  * d/control: build-depend on :native variant of mingw gcc/tools
    (helps building for bookworm where these tools aren't M-A:foreign)

 -- Michael Tokarev <mjt@tls.msk.ru>  Sun, 14 Sep 2025 15:35:35 +0300

samba (2:4.23.0+dfsg-1) unstable; urgency=medium

  * new upstream release
  * d/watch: 4.23
  * d/gbp.conf: switch to 4.23 upstream branch
  * d/rules: tevent=0.17.1 tdb=1.4.14
  * libads-fix-get_kdc_ip_string.patch: remove (included upstream)
  * d/copyright: remove entries for two removed files
  * d/libpam-winbind.install: install message catalogs
  * d/samba-common-bin.install: install message catalog(s) for the net command
  * d/libsmbclient0.symbols,d/libtevent0t64.symbols: add new symbols
  * d/libtdb1.symbols: add new version
  * d/samba-dsdb-modules.install: add new AD module (trust_notify.so)
  * d/samba-libs.install: refresh private libraries list (-1, +4 libs)
  * d/samba-libs.preinst: remove, used in distant past
    for upgrades from ancient versions
  * d/control: stop recommending samba-ad-dc (and python3-samba)
    from samba package (was needed for transition)
  * d/control: stop recommending attr by samba
  * d/control: remove pre-bookworm (samba<<4.17) breaks/replaces
  * d/control: stop samba from being dependent on procps
    (ps was used in initscript long ago)
  * d/control: stop ctdb from being dependent on psmisc and sudo
  * stop ctdb from depending on time package
  * d/libnss-winbind.triggers: remove, ldconfig call is generated by genshlibs
  * d/rules: explicitly specify --pythondir= & --pythonarchdir=
    (so it doesn't install to /usr/lib/python3.13/site-packages/)
  * d/rules,d/lib{nss,pam}-winbind.install: use ${SYSLIBDIR}
    for /lib vs /usr/lib, stop using dh_movetousr

 -- Michael Tokarev <mjt@tls.msk.ru>  Fri, 12 Sep 2025 12:38:48 +0300

=== debian/control ===
--- 
+++ 
@@ -1,3 +1,7 @@
+# Available build profiles:
+#  pkg.samba.before-trixie: no t64, no usrmerge, no rpcsvc-proto
+#  pkg.samba.builtin-ngtcp2: use built-in ngtcp2 (required version of libngtcp2 is >= 1.12.0)
+#  pkg.samba.dumpmscat: build /usr/bin/dumpmscat binary
 Source: samba
 Section: net
 Priority: optional
@@ -12,7 +16,7 @@
 	dh-exec,
 Build-Depends-Arch:
 	dh-sequence-python3,
-        python3-setuptools,
+	python3-setuptools,
 	dpkg-dev (>= 1.22.5) <!pkg.samba.before-trixie>,
 # tools:
 	bison,
@@ -23,7 +27,7 @@
 	libparse-yapp-perl:native | libparse-yapp-perl,
 	rpcsvc-proto  <!pkg.samba.before-trixie>,
 # for winexe. gcc-mingw-w64 brings 4 toolchains, we need only 2
-        gcc-mingw-w64-i686-win32, gcc-mingw-w64-x86-64-win32,
+	gcc-mingw-w64-i686-win32:native, gcc-mingw-w64-x86-64-win32:native,
 # system libraries:
 	pkgconf,
 	libacl1-dev,
@@ -49,16 +53,16 @@
 	libkrb5-dev (>= 1.21.0~) <pkg.samba.mitkrb5>,
 	libldap2-dev,
 	liblmdb-dev,
-#	libngtcp2-dev (>> 1.12.0~) [linux-any],
-#	libngtcp2-crypto-gnutls-dev (>> 1.12.0~) [linux-any],
+	libngtcp2-dev (>> 1.12.0~) [linux-any] <!pkg.samba.builtin-ngtcp2>,
+	libngtcp2-crypto-gnutls-dev (>> 1.12.0~) [linux-any] <!pkg.samba.builtin-ngtcp2>,
 	libpam0g-dev,
 	libpcap-dev [hurd-any],
 	libpopt-dev,
 	libreadline-dev,
 	libtirpc-dev,
 	libsystemd-dev [linux-any],
-	libtasn1-6-dev,
-	libtasn1-bin,
+	libtasn1-6-dev <pkg.samba.dumpmscat>,
+	libtasn1-bin <pkg.samba.dumpmscat>,
 	liburing-dev [linux-any],
 # xfslibs-dev is not multi-arch-usable but we only need .h (#1092689)
 	xfslibs-dev:native [linux-any],
@@ -77,6 +81,9 @@
 #	python3-iso8601 <!nocheck>,
 #	python3-pyasn1 <!nocheck>,
 #	tdb-tools <!nocheck>,
+Build-Conflicts-Arch:
+ libngtcp2-dev <pkg.samba.builtin-ngtcp2>,
+ libtasn1-bin <!pkg.samba.dumpmscat>,
 Rules-Requires-Root: no
 Vcs-Browser: https://salsa.debian.org/samba-team/samba
 Vcs-Git: https://salsa.debian.org/samba-team/samba.git
@@ -85,21 +92,17 @@
 Architecture: any
 Pre-Depends: ${misc:Pre-Depends}
 Depends: passwd,
-         procps,
          samba-common,
          samba-common-bin (=${binary:Version}),
          ${misc:Depends},
          ${python3:Depends},
          ${shlibs:Depends}
-Recommends: attr,
-            python3-samba,
-# samba-ad-dc has been split out of samba in 4.20.1+dfsg-2.  Keep it
-# in Recommends for one release cycle to avoid breaking existing installs
-            samba-ad-dc,
 Suggests: ctdb,
           ufw,
           winbind,
+          python3-samba,
           samba-vfs-ceph, samba-vfs-glusterfs,
+          attr,
 # move libdfs-server-ad-samba4.so.0 samba-libs=>samba-vfs-modules in 4.19.0~rc1
 # swallow samba-vfs-modules by samba in 4.20.2-dfsg-3
 Replaces: samba-libs (<< 2:4.19.0~),
@@ -138,14 +141,7 @@
 # just require libldb version of the same build
 # https://lists.samba.org/archive/samba-technical/2023-September/138422.html
  libldb2 (= ${ldb:Version}),
-Replaces:
-# libsamba-util.so &deps moved from libwbclient0 to samba-libs in 4.16.1+dfsg-7
- libwbclient0 (<< 2:4.16.1+dfsg-7~),
-# libpac-samba4.so.0 moved from samba to samba-libs in 4.17.0+dfsg-2
- samba (<< 2:4.17.0+dfsg-2~),
 Breaks:
- libwbclient0 (<< 2:4.16.1+dfsg-7~),
- samba (<< 2:4.17.0+dfsg-2~),
  sssd-ad (<< 2.9.4-1+b1),
  sssd-ad-common (<< 2.9.4-1+b1),
  sssd-ipa (<< 2.9.4-1+b1),
@@ -242,8 +238,6 @@
 Pre-Depends: ${misc:Pre-Depends}
 Depends: ${misc:Depends},
  python3-markdown,
-Replaces: samba (<< 2:4.17.3+dfsg-4~)
-Breaks:   samba (<< 2:4.17.3+dfsg-4~)
 Description: Samba files needed for AD domain provision
  Samba is an implementation of the SMB/CIFS protocol for Unix systems,
  providing support for cross-platform file and printer sharing with
@@ -313,5 +307,7 @@
          libwbclient-dev,
          samba-libs (= ${binary:Version}),
          ${misc:Depends}
-# libsamba-util.so moved from libwbclient0 to samba-libs in 4.16.1+dfsg-7
-Replaces: libwbclient-dev (<< 2:4.16.1+dfsg-7~)
+Section: devel
+Description: tools for extending Samba
+ Samba is an implementation of the SMB/CIFS protocol for Unix systems,
+ providing support for cross-platform file sharing with Microsoft Windows, OS X,

## samba 4.23.1+dfsg

=== debian/changelog ===
samba (2:4.23.1+dfsg-1) unstable; urgency=medium

  [ Michael Tokarev ]
  * new upstream stable/bugfix release (Closes: #1116050):
   - https://bugzilla.samba.org/show_bug.cgi?id=15904:
     CTDB does not support PCP 7.0.0
   - https://bugzilla.samba.org/show_bug.cgi?id=15914:
     winbind can crash at startup
   - https://bugzilla.samba.org/show_bug.cgi?id=15919:
     vfs_ceph_new should not use ceph_ll_nonblocking_readv_writev
     for fsync_send
   - https://bugzilla.samba.org/show_bug.cgi?id=15920:
     Incomplete bind configuration causes DLZ plugin to crash
   - https://bugzilla.samba.org/show_bug.cgi?id=15921:
     CTDB_SOCKET can be used even when CTDB_TEST_MODE is not set
  * d/control: describe the forgotten mitkrb5 build profile
  * d/control: Standards-Version: 4.7.2 (no changes)
  * d/control: sort python build-deps together
  * d/control: clarify some :native usages and add non-:native
    alternatives for gcc-mingw*
  * d/control: clarify python3-dev:native, libpython3-dev:host
  * usershare.patch: remove
  * d/samba.postinst: add `usershare max shares` parameter on upgrade
  * debian/samba{,-libs}.lintian-overrides: remove unused
    hardening-no-fortify-functions overrides

  [ Grzegorz Szymaszek ]
  * d/smb.conf: delete trailing spaces in comments

 -- Michael Tokarev <mjt@tls.msk.ru>  Fri, 26 Sep 2025 22:31:59 +0300

## samba 4.23.2%2Bdfsg

=== ctdb/wscript ===
#!/usr/bin/env python

APPNAME = 'ctdb'

import sys, os

# find the buildtools directory
top = '.'
while not os.path.exists(top+'/buildtools') and len(top.split('/')) < 5:
    top = top + '/..'
sys.path.insert(0, top + '/buildtools/wafsamba')

out = 'bin'

from waflib import Options, Logs, Errors, Context
import wafsamba
from wafsamba import samba_dist, samba_utils
from samba_utils import MODE_644, MODE_744, MODE_755, MODE_777

if os.path.isfile('./VERSION'):
    vdir = '.'
elif os.path.isfile('../VERSION'):
    vdir = '..'
else:
    Logs.error("VERSION file not found")

default_prefix = Options.default_prefix = '/usr/local'

samba_dist.DIST_DIRS('''ctdb:. lib/replace:lib/replace lib/talloc:lib/talloc
                        lib/tevent:lib/tevent lib/tdb:lib/tdb
                        third_party/socket_wrapper:third_party/socket_wrapper
                        third_party/popt:third_party/popt
                        lib/util:lib/util lib/tdb_wrap:lib/tdb_wrap
                        lib/ccan:lib/ccan libcli/util:libcli/util
                        lib/async_req:lib/async_req
                        lib/pthreadpool:lib/pthreadpool
                        lib/messaging:lib/messaging
                        buildtools:buildtools third_party/waf:third_party/waf''')

manpages_binary = [
    'ctdb.1',
    'ctdbd.1',
    'ltdbtool.1',
    'ping_pong.1'
]

manpages_misc = [
    'ctdb_diagnostics.1',
    'onnode.1',
    'ctdb.conf.5',
    'ctdb-script.options.5',
    'ctdb.sysconfig.5',
    'ctdb.7',
    'ctdb-statistics.7',
    'ctdb-tunables.7',
]

manpages_etcd = [
    'ctdb-etcd.7',
]

manpages_ceph = [
    'ctdb_mutex_ceph_rados_helper.7',
]

VERSION = ''

def get_version():
    import samba_version
    env = samba_utils.LOAD_ENVIRONMENT()

    return samba_version.samba_version_file('%s/VERSION' % vdir, vdir, env)

def get_version_string():
    if Context.g_module.VERSION:
        return Context.g_module.VERSION
    version = get_version()
    Context.g_module.VERSION = version.STRING.replace('-', '.')
    return Context.g_module.VERSION

def options(opt):
    opt.PRIVATE_EXTENSION_DEFAULT('ctdb')

    opt.RECURSE('lib/replace')

    opt.RECURSE('lib/util')

    opt.RECURSE('lib/talloc')
    opt.RECURSE('lib/tevent')
    opt.RECURSE('lib/tdb')

    opt.add_option('--enable-infiniband',
                   help=("Turn on infiniband support (default=no)"),
                   action="store_true", dest='ctdb_infiniband', default=False)
    opt.add_option('--enable-pmda',
                   help=("Turn on PCP pmda support (default=no)"),
                   action="store_true", dest='ctdb_pmda', default=False)
    opt.add_option('--enable-etcd-reclock',
                   help=("Enable etcd recovery lock helper (default=no)"),
                   action="store_true", dest='ctdb_etcd_reclock', default=False)
    opt.add_option('--enable-pcap',
                   help=("Use pcap for packet capture (default=no)"),
                   action="store_true", dest='ctdb_pcap', default=False)

    opt.add_option('--enable-ceph-reclock',
                   help=("Enable Ceph CTDB recovery lock helper (default=no)"),
                   action="store_true", dest='ctdb_ceph_reclock', default=False)

    opt.add_option('--with-logdir',
                   help=("Path to log directory"),
                   action="store", dest='ctdb_logdir', default=None)
    opt.add_option('--with-socketpath',
                   help=("path to CTDB daemon socket"),
                   action="store", dest='ctdb_sockpath', default=None)


def configure(conf):
    # No need to build python bindings for talloc/tevent/tdb
    if conf.IN_LAUNCH_DIR():
        conf.env.standalone_ctdb = True
        Options.options.disable_python = True

    conf.RECURSE('lib/replace')

    conf.CHECK_HEADERS(headers='''sys/socket.h
                                  netinet/in.h
                                  netinet/if_ether.h
                                  netinet/ip.h
                                  netinet/ip6.h
                                  netinet/icmp6.h''',
                       together=True)

    conf.CHECK_CODE('int s = socket(AF_PACKET, SOCK_RAW, 0);',
                    define='HAVE_AF_PACKET',
                    headers='sys/socket.h linux/if_packet.h')

    conf.CHECK_CODE('struct sockaddr_ll sall; sall.sll_family = AF_PACKET;',
                    define='HAVE_PACKETSOCKET',
                    headers='sys/socket.h linux/if_packet.h')

    conf.CHECK_CODE('''pthread_mutex_t m;
                       int pid = 0;
                       m.__data.__owner = pid;
                    ''',
                    'HAVE_PTHREAD_INTERNAL_MUTEX_OWNER',
                    headers='pthread.h',
                    msg='Checking for internal POSIX mutex owner field')
    if not conf.env.HAVE_PTHREAD_INTERNAL_MUTEX_OWNER:
        # This is unsupported - please see note in debug_locks.sh
        Logs.info('Building without unsupported mutex debugging hack')

    if conf.env.standalone_ctdb:
        conf.SAMBA_CHECK_PERL(mandatory=True)

        # This is just for consistency and to check the version for the
        # build system, see Options.options.disable_python = True above
        conf.SAMBA_CHECK_PYTHON()
        conf.SAMBA_CHECK_PYTHON_HEADERS()

        # We just want gnutls_rnd for rand subsystem
        conf.CHECK_FUNCS_IN('gnutls_rnd', 'gnutls')


    if conf.CHECK_FOR_THIRD_PARTY():
        conf.RECURSE('third_party/popt')
        if conf.env.standalone_ctdb or conf.CONFIG_GET('ENABLE_SELFTEST'):
            conf.RECURSE('third_party/socket_wrapper')
            conf.env.SOCKET_WRAPPER_SO_PATH = conf.CONFIG_GET('LIBSOCKET_WRAPPER_SO_PATH')
    else:
        if not conf.CHECK_POPT():
            raise Errors.WafError('popt development packages have not been found\nIf third_party is installed, check that it is in the proper place.')
        else:
            conf.define('USING_SYSTEM_POPT', 1)
        conf.env.SOCKET_WRAPPER_SO_PATH = ''


        if conf.env.standalone_ctdb or conf.CONFIG_GET('ENABLE_SELFTEST'):
            if not conf.CHECK_SOCKET_WRAPPER():
                raise Errors.WafError('socket_wrapper package has not been found.\nIf third_party is installed, check that it is in the proper place.')
            else:
                conf.define('USING_SYSTEM_SOCKET_WRAPPER', 1)
                conf.env.SOCKET_WRAPPER_SO_PATH = conf.CONFIG_GET('LIBSOCKET_WRAPPER_SO_PATH')

    conf.RECURSE('lib/util')

    conf.RECURSE('lib/talloc')
    conf.RECURSE('lib/tevent')
    conf.RECURSE('lib/tdb')

    conf.CHECK_HEADERS('sched.h')
    conf.CHECK_HEADERS('procinfo.h')
    if sys.platform.startswith('aix') and not conf.CHECK_FUNCS('thread_setsched'):
        Logs.error('Need thread_setsched() on AIX')
        sys.exit(1)
    elif not conf.CHECK_FUNCS('sched_setscheduler'):
        Logs.error('Need sched_setscheduler()')
        sys.exit(1)
    conf.CHECK_FUNCS('mlockall')
    conf.CHECK_FUNCS('getrusage', headers="sys/time.h sys/resource.h")

    if not conf.CHECK_VARIABLE('ETIME', headers='errno.h'):
        conf.DEFINE('ETIME', 'ETIMEDOUT')

    if Options.options.ctdb_pcap or not sys.platform.startswith('linux'):
        conf.DEFINE('ENABLE_PCAP', 1)
    if not conf.env.ENABLE_PCAP:
        conf.SET_TARGET_TYPE('pcap', 'EMPTY')
    else:
        conf.find_program('pcap-config', var='PCAP_CONFIG')
        if conf.env.PCAP_CONFIG:
            conf.CHECK_CFG(path=conf.env.PCAP_CONFIG,
                           args="--cflags --libs",
                           package="",
                           uselib_store="PCAP")
        if not conf.CHECK_HEADERS('pcap.h'):
            Logs.error('Need libpcap')
            sys.exit(1)
        if not conf.CHECK_FUNCS_IN('pcap_open_live', 'pcap', headers='pcap.h'):
            Logs.error('Need libpcap')
            sys.exit(1)
        conf.CHECK_FUNCS_IN('pcap_set_immediate_mode', 'pcap', headers='pcap.h')

    if not conf.CHECK_FUNCS_IN('backtrace backtrace_symbols', 'execinfo',
                               checklibc=True, headers='execinfo.h'):
        Logs.error('backtrace support not available')

    have_pmda = False
    if Options.options.ctdb_pmda:
        checks = [conf.CHECK_HEADERS('pcp/pmapi.h pcp/impl.h pcp/pmda.h',
                                     together=True),
                  conf.CHECK_FUNCS_IN('pmdaDaemon', 'pcp_pmda')]

        have_progname = [conf.CHECK_FUNCS_IN('pmProgname', 'pcp'),
                         conf.CHECK_FUNCS_IN('pmGetProgname', 'pcp'),
                         conf.CHECK_FUNCS_IN('pmSetProgname', 'pcp')]

        conf.CHECK_TYPE_IN('struct pmResult', 'pcp/pmapi.h')

        if all(checks) and any(have_progname):
            conf.CHECK_TYPE_IN('__pmID_int', 'pcp/pmapi.h pcp/impl.h')
            have_pmda = True
        else:
            Logs.error("PMDA support not available")
            sys.exit(1)
    if have_pmda:
        Logs.info('Building with PMDA support')
        conf.define('HAVE_PMDA', 1)
        conf.env.CTDB_PMDADIR = os.path.join(conf.env.LOCALSTATEDIR,
                                             'lib/pcp/pmdas/ctdb')

    have_infiniband = False
    if Options.options.ctdb_infiniband:
        ib_support = True

        if not conf.CHECK_HEADERS('infiniband/verbs.h rdma/rdma_cma.h'):
            ib_support = False
        if not conf.CHECK_FUNCS_IN('ibv_create_qp', 'ibverbs'):
            ib_support = False
        if not conf.CHECK_FUNCS_IN('rdma_connect', 'rdmacm'):
            ib_support = False
        if ib_support:
            have_infiniband = True
        else:
            Logs.error("Infiniband support not available")
            sys.exit(1)
    if have_infiniband:
        Logs.info('Building with Infiniband support')
        conf.define('HAVE_INFINIBAND', 1)
        conf.define('USE_INFINIBAND', 1)

    have_etcd_reclock = False
    if Options.options.ctdb_etcd_reclock:
        try:
            conf.check_python_module('etcd')
            have_etcd_reclock = True
        except:
            Logs.error('etcd support not available')
            sys.exit(1)
    if have_etcd_reclock:
        Logs.info('Building with etcd support')
    conf.env.etcd_reclock = have_etcd_reclock

    if Options.options.ctdb_ceph_reclock:
        if (conf.CHECK_HEADERS('rados/librados.h', False, False, 'rados') and
					conf.CHECK_LIB('rados', shlib=True)):
            Logs.info('Building with Ceph librados recovery lock support')
            conf.define('HAVE_LIBRADOS', 1)
        else:
            Logs.error("Missing librados for Ceph recovery lock support")
            sys.exit(1)

    conf.env.CTDB_BINDIR = os.path.join(conf.env.EXEC_PREFIX, 'bin')
    conf.env.CTDB_DATADIR = os.path.join(conf.env.EXEC_PREFIX, 'share/ctdb')
    conf.env.CTDB_ETCDIR = os.path.join(conf.env.SYSCONFDIR, 'ctdb')
    conf.env.CTDB_VARDIR = os.path.join(conf.env.LOCALSTATEDIR, 'lib/ctdb')
    conf.env.CTDB_RUNDIR = os.path.join(conf.env.LOCALSTATEDIR, 'run/ctdb')
    conf.env.CTDB_HELPER_BINDIR = os.path.join(conf.env.LIBEXECDIR, 'ctdb')

    if Options.options.ctdb_logdir:
        conf.env.CTDB_LOGDIR = Options.options.ctdb_logdir
    else:
        conf.env.CTDB_LOGDIR = os.path.join(conf.env.LOCALSTATEDIR, 'log')

    if Options.options.ctdb_sockpath:
        conf.env.CTDB_SOCKPATH = Options.options.ctdb_sockpath
    else:
        conf.env.CTDB_SOCKPATH = os.path.join(conf.env.CTDB_RUNDIR,
                                              'ctdbd.socket')
    conf.define('CTDB_SOCKET', conf.env.CTDB_SOCKPATH)

    conf.ADD_CFLAGS('''-DCTDB_HELPER_BINDIR=\"%s\"
                       -DLOGDIR=\"%s\"
                       -DCTDB_DATADIR=\"%s\"
                       -DCTDB_ETCDIR=\"%s\"
                       -DCTDB_VARDIR=\"%s\"
                       -DCTDB_RUNDIR=\"%s\"''' % (
                    conf.env.CTDB_HELPER_BINDIR,
                    conf.env.CTDB_LOGDIR,
                    conf.env.CTDB_DATADIR,

=== testprogs/win32/rpcecho/Makefile ===
INCLUDES=-I 
CFLAGS=$(INCLUDES) -Zi -nologo
LIBS=rpcrt4.lib

all: client server

clean:
	del *~ *.obj client server rpcecho_c.c rpcecho_s.c rpcecho.h

rpcecho.h rpcecho_s.c rpcecho_c.c: rpcecho.idl rpcecho.acf
	midl rpcecho.idl

client: client.obj rpcecho_c.obj utils.obj
	$(CC) $(CFLAGS) -o client client.obj rpcecho_c.obj utils.obj $(LIBS)

server: server.obj rpcecho_s.obj utils.obj
	$(CC) $(CFLAGS) -o server server.obj rpcecho_s.obj utils.obj $(LIBS)

client.obj: rpcecho.h client.c
server.obj: rpcecho.h server.c
rpcecho_c.obj: rpcecho.h rpcecho_c.c
rpcecho_s.obj: rpcecho.h rpcecho_s.c
utils.obj: rpcecho.h utils.c
